/* -*- Mode: C; c-file-style: "stroustrup" -*- */
#ifndef _NUMEXP_KERNEL_H_
#define _NUMEXP_KERNEL_H_

#include <libbonobo.h>
#include "Numexp_Kernel.h"
#include "nxp_kernel.h"

G_BEGIN_DECLS

#define NUMEXP_KERNEL_TYPE         (numexp_kernel_get_type ())
#define NUMEXP_KERNEL(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), NUMEXP_KERNEL_TYPE, NumexpKernel))
#define NUMEXP_KERNEL_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), NUMEXP_KERNEL_TYPE, NumexpKernelClass))
#define NUMEXP_KERNEL_IS_OBJECT(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), NUMEXP_KERNEL_TYPE))
#define NUMEXP_KERNEL_IS_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), NUMEXP_KERNEL_TYPE))
#define NUMEXP_KERNEL_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), NUMEXP_KERNEL_TYPE, NumexpKernelClass))



typedef struct {
    BonoboObject     parent;
    Numexp_Client    client;
    NxpEvalContext  *context;
    GSource         *listeners_timeout;
} NumexpKernel;

typedef struct {
    BonoboObjectClass parent_class;
    
    POA_Numexp_Kernel__epv epv;
} NumexpKernelClass;

GType                   numexp_kernel_get_type       (void);
BonoboObject*           numexp_kernel_new            (void);
NxpElement*             numexp_kernel_ref2element    (Numexp_Element           ref);
Numexp_Element          numexp_kernel_element2ref    (NxpElement              *elem);
NxpDefinition*          numexp_kernel_ref2definition (Numexp_DefinitionHandle  ref);
Numexp_DefinitionHandle numexp_kernel_definition2ref (NxpDefinition           *def);
void gerror_to_exception(GError *err, CORBA_Environment *ev);


#define ref2element    numexp_kernel_ref2element
#define element2ref    numexp_kernel_element2ref
#define ref2definition numexp_kernel_ref2definition
#define definition2ref numexp_kernel_definition2ref


G_END_DECLS

#endif /* _NUMEXP_KERNEL_H_ */
