/* -*- Mode: C; c-file-style: "bsd"; -*- */

/* Complexeger Complex relation */

#include <math.h>
#include <string.h>
#include "int.h"
#include "nxp_complex.h"
#include "nxp_string.h"
#include "op_bindings.h"
#include "types_misc.h"

#define BIND_SYM(func,op)    nxp_bind_operator_function(op, NXP_ELEMENT_TYPE_STRING, \
							NXP_ELEMENT_TYPE_COMPLEX, \
   			                              func, func, NXP_OP_BIND_SYMMETRIC, NULL);

static NxpElement* or(NxpOp op, NxpElement *a, NxpElement *b, 
		       NxpEvalContext *context, GError **error) {
	return nxp_element_complex_new_from_dbl((strlen(NXP_ELEMENT_STRING(a)->string))?1:
				       nxp_element_complex_get_value(NXP_ELEMENT_COMPLEX(b)));
}

static NxpElement* and(NxpOp op, NxpElement *a, NxpElement *b, 
		       NxpEvalContext *context, GError **error) {
	return nxp_element_complex_new_from_dbl((strlen(NXP_ELEMENT_STRING(a)->string))?
				       nxp_element_complex_get_value(NXP_ELEMENT_COMPLEX(b)):0);
}

void nxp_element_string_complex_init(GError **error)
{
    
    // BIND_SYM(add_them, NXP_OP_PLUS);
    // NXP_OP_MINUS_LEFT 
    // BIND_SYM(mult_them,NXP_OP_STAR);

    //  BIND_COMPLEX_COMPLEX(sub_complex_complex, NXP_OP_MINUS);
    //  BIND_COMPLEX_COMPLEX(sub_complex_complex, NXP_OP_MINUS);

    // BIND_COMPLEX_COMPLEX(div_complex_complex, NXP_OP_SLASH);
    // BIND_COMPLEX_COMPLEX(div_complex_complex, NXP_OP_SLASH);

    // BIND_COMPLEX_COMPLEX(hat_complex_complex, NXP_OP_HAT);
    // BIND_COMPLEX_COMPLEX(hat_complex_complex, NXP_OP_HAT);

    // NXP_OP_DOT3... TODO
  
    // PLUS2_left/right MINUS2/left/right in complex.c or complex.c

    // BIND_COMPLEX_COMPLEX(gt_complex_complex, NXP_OP_GT);
    // BIND_COMPLEX_COMPLEX(gt_complex_complex, NXP_OP_GT);

    // BIND_COMPLEX_COMPLEX(lt_complex_complex, NXP_OP_LT);
    // BIND_COMPLEX_COMPLEX(lt_complex_complex, NXP_OP_LT);

    // BIND_COMPLEX_COMPLEX(gte_complex_complex, NXP_OP_GT_EQ);
    // BIND_COMPLEX_COMPLEX(gte_complex_complex, NXP_OP_GT_EQ);

    //BIND_COMPLEX_COMPLEX(lte_complex_complex, NXP_OP_LT_EQ);
    // BIND_COMPLEX_COMPLEX(lte_complex_complex, NXP_OP_LT_EQ);

    // BIND_SYM(equals,NXP_OP_EQ2);
    // BIND_SYM(nequals,NXP_OP_EXCL_EQ);

    BIND_SYM(and,NXP_OP_SLASH_BSLASH);
    BIND_SYM(or, NXP_OP_BSLASH_SLASH);

    // TILDE LEFT is handled under complex.c or complex.c
    // EXCL_RIGHT is handled under complex.c or complex.c

    // BIND_SYM(atrib_error, NXP_OP_EQ);
    // BIND_SYM(atrib_error, NXP_OP_COLON_EQ);
}

