/* -*- c -*- */
#include <gsl/gsl_sf_exp.h>
#include "nxp_kernel.h"
#include "gsl.h"

static NxpElement *nxp_gsl_sf_exp(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_exp(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_exp_mult(NxpElementReal *arg1 ,NxpElementReal *arg2, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_exp_mult(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_expm1(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_expm1(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_exprel(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_exprel(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_exprel_2(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_exprel_2(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_exprel_n(NxpElementInt *arg1 ,NxpElementReal *arg2, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_exprel_n(nxp_element_int_get_si(NXP_ELEMENT_INT(arg1), error) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)));
	GSL_RETURN(nxp_element_real_new(ret));
}


static NxpElement *
nxp_gsl_sf_exp_err_e(NxpElementReal * X, NxpElementReal * DX, ETC)
{
    NxpElement     *nxp_result;
    gsl_sf_result   result;

    gsl_sf_exp_err_e(nxp_element_r_get_value_as_double(X), nxp_element_r_get_value_as_double(DX), &result);
    nxp_result = nxp_element_vector_new(2, NULL);
    NXP_ELEMENT_VECTOR_ELEM(NXP_ELEMENT_VECTOR(nxp_result), 0) =
	nxp_element_real_new(result.val);
    NXP_ELEMENT_VECTOR_ELEM(NXP_ELEMENT_VECTOR(nxp_result), 1) =
	nxp_element_real_new(result.err);

    GSL_RETURN(nxp_result);
}


void
nxp_gsl_sf_exp_init(NxpEvalContext * context)
{
    NxpIdentifier  *id;
nxp_name_space_new(context->cwd,"gsl");
nxp_name_space_new(nxp_name_space_find_child(context->cwd,"gsl"),"exp");
id = nxp_identifier_new_with_full_path(3,"gsl","exp", "exp");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_exp, NULL, nxp_gsl_sf_exp, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","exp", "expMult");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_exp_mult, NULL, nxp_gsl_sf_exp_mult, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","exp", "expMinus1");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_expm1, NULL, nxp_gsl_sf_expm1, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","exp", "expRelative");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_exprel, NULL, nxp_gsl_sf_exprel, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","exp", "expRelative2");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_exprel_2, NULL, nxp_gsl_sf_exprel_2, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","exp", "expRelativeN");
 nxp_bifunc_define(id, &nxp_prototype__INT_REAL, nxp_gsl_sf_exprel_n, NULL, nxp_gsl_sf_exprel_n, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","exp", "expErr");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_exp_err_e, NULL, nxp_gsl_sf_exp_err_e, context, NULL); nxp_identifier_unref(id);
}
