/* -*- Mode: C; c-file-style: "bsd"; -*- */

#include "nxp_kernel.h"
#include "config.h"
#include "i18n.h"
#include "functions.h"
#include "kernel/types/tree.h"

NxpElement* stdlib_eval_sleep(NxpElementR *el, ETC)
{ 
    nxp_real_t val = nxp_element_r_get_value_as_double(el);
    struct timespec delay;

    if (val < 0) {
	g_set_error(error, nxp_error_domain, NXP_ERROR_DOMAIN,
		    _("Negative time not accepted for sleep()"));
	return NULL;
    }
    delay.tv_sec = val;
    delay.tv_nsec = (val - delay.tv_sec)*1e9;
    nanosleep(&delay, NULL);
    return nxp_element_void_new();
} 
